#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include "GeoIP.h"
#include "GeoIPCity.h"
#define YES 1
#define NO 0
#define MAX 32768 
    char *line;
    char my_buff[MAX];
    char Line[1024];
    char Candc[50];

int in[2];      /* stdin pipe Main->Child */
char NumIp[50],GeoIp[512];
        GeoIP * gi;
        GeoIPRecord * gir;
int GeoIp_YesNo=YES;
int  getfieldsandreplace(char * line);
char *getcountryandcity(unsigned long int);
long unsigned getipnum(char *ip_a);

void oops(char *err, int exit_code)
{
    fprintf(stderr, "%s\n", err);
    exit(exit_code);
}

void my_child(void)
{
      int c;
      long unsigned int count=0;

      close(in[0]);
      while( read(0,my_buff,MAX-1) )
                    write(in[1], my_buff, MAX-1); 
      close(in[1]);

}
void my_parent(void)
{
    int c,i=0;
    char *p1,*p2;
               close(in[1]);
               p1=my_buff;
               while(read(in[0],my_buff,MAX-1)){ 
                   while(   (p2=strchr(p1,'\n')) != NULL ){
                      strncpy(Line,p1, (p2-p1)+1 );                     
                      Line[( (p2-p1)+1 )]='\0';  
                      p1=p2;p1++;  
                      /*write(1, Line, strlen(Line));*/ 
                      getfieldsandreplace(Line);
                   }
                   p1=my_buff;
               }       


               close(in[0]); 
wait(0);
}

main()
{
    static int watch=1;
    pid_t pid;
    int i=0;
    if(watch){
           watch=0;
           OpenGeoDatabase();
           if(-1 == pipe(in))
           oops("pipe error 1", 1);
           pid=fork();
    }
    if(pid){
            my_parent();
    }
    else{
            my_child();
    }
}
int  getfieldsandreplace(char * line)
{
   int i=0,j=0,k=0;
   int once=0;
   int field=0;
   char *geocc;
   char *p1,*p2;
   int quotecount=0;
   int c='\n';
       if(line !=NULL){

           for(k=0;k<strlen(line);k++){
                               if( (isdigit(Line[k]) || Line[k]=='.') && Line[k] != ' '){
                                     NumIp[j++]=line[k];
                               }
                               else{
                                     NumIp[j++]=0;
                                     field=1;
                                     write(1, Line,j);
                                     line +=j;
                                     break;
                               }
           }            
           while( p1=strchr(line,'"') ){
                         if(quotecount !=5) 
                         write( 1, line, (p1-line)+1 );
                         line=p1; 
                         line++; 
                         quotecount++;
                         if(quotecount==5){
                                     if(GeoIp_YesNo){
                                                geocc=getcountryandcity( getipnum( (char *)NumIp ));
                                                /* sprintf(geocc,"GeoIp; Unknown\""); */
                                                if(geocc != NULL){
                                                             GeoIp[0]=0;
                                                             sprintf(GeoIp,"GeoIp; %s^\"",geocc);
                                                             write(1, GeoIp,strlen(GeoIp));
                                                 }
                                     }
                                     
                         } 
           }  
           write(1,&c,1);
       }

 return 1 ;
}
int OpenGeoDatabase(void)
{
        if(GeoIp_YesNo)
        gi = GeoIP_open("/home/staff/install/analog-6.0/GeoIP-1.4.4/data/GeoLiteCity.dat", GEOIP_INDEX_CACHE);
        if (gi == NULL) {
                GeoIp_YesNo=NO;
                return NO;
        }
 return YES;
}
char *getcountryandcity(unsigned long int ip)
{
               gir = GeoIP_record_by_ipnum(gi, ip);
                if (gir != NULL) {
                        sprintf(Candc,"%s:%s",gir->country_name,(gir->city)==NULL ? "Unknown" : (gir->city));
                        GeoIPRecord_delete(gir);
                        /* GeoIP_delete(gi); */
                        return Candc;
                }
                else return NULL;
}
long unsigned getipnum(char *ip_a)
{
   int i,j=0;
   int ipwatch=0;
   char ipchar[24];
   char tempip[10];
   long unsigned ip[4],IP;
   if(ip_a != NULL){
               strcpy(ipchar,ip_a);
               for(i=0;i<strlen(ipchar)+1;i++){
                                if( (ipchar[i]==0 || ipchar[i]== '.') ){
                                      tempip[j]=0;
                                      ip[ipwatch]=(long unsigned)atol(tempip);
                                      ipwatch++;
                                      j=0;
                                      tempip[0]=0;
                                }
                                else
                                tempip[j++]=ipchar[i];
               }
   }
   return (16777216*ip[0] + 65536*ip[1] + 256*ip[2] + ip[3]);
}

